#ifndef FORM_OB
#define FORM_OB
#include <string.h>
#include <stdlib.h>
#include <fstream.h>
class Tablica_obiektow;

class Format_obiektow
{
public:
  Format_obiektow () {}
  ~Format_obiektow() {}

  void Zachowaj_poczatek_def(ofstream& plik_wy)
   {Zachowaj_etykiete(plik_wy, "Definicja_obiektu");
    plik_wy<<endl;}

  void Zachowaj_koniec_def(ofstream& plik_wy)
   {Zachowaj_etykiete(plik_wy, "\\Definicja_obiektu");
    plik_wy<<endl;}

  virtual void Zachowaj(ofstream& plik_wy)
   { Zachowaj_poczatek_def(plik_wy);
     Zachowaj_nazwe_klasy(plik_wy);
     Zachowaj_atrybuty(plik_wy);
     Zachowaj_powiazania(plik_wy);
     Zachowaj_koniec_def(plik_wy);
   }

  virtual void Zachowaj_powiazania(ofstream& plik_wy) {}
  virtual void Zachowaj_nazwe_klasy(ofstream& plik_wy){}//=0;
  virtual void Zachowaj_atrybuty(ofstream& plik_wy){}//=0;

  void Odtworz_poczatek_def(ifstream& plik_we)
  {char znak;
   Odtworz_etykiete(plik_we,"Definicja_obiektu");
   plik_we.get(znak);}

  void Odtworz_koniec_def(ifstream& plik_we)
  { char znak;
   Odtworz_etykiete(plik_we,"\\Definicja_obiektu");
   plik_we.get(znak);}

  char* Odtworz_nazwe_klasy(ifstream& plik_we)
   { Odtworz_etykiete(plik_we,"Nazwa_klasy");
     return Odtworz_nazwe(plik_we);}

  virtual void Odtworz(ifstream& plik_we,Tablica_obiektow* tablica_obiektow)
   {
     Odtworz_poczatek_def(plik_we);
     Odtworz_nazwe_klasy(plik_we);
     Odtworz_atrybuty(plik_we);
     Odtworz_powiazania(plik_we,tablica_obiektow);
     Odtworz_koniec_def(plik_we);
     }

  virtual void Odtworz_powiazania(ifstream& plik_we,
				  Tablica_obiektow* tablica_obiektow) {}

  virtual void Odtworz_atrybuty(ifstream& plik_we){}//=0;

  virtual void Nadaj_obiekt(void* _obiekt){}//=0;

   void Zachowaj_etykiete(ofstream& plik_wy, char* etykieta)
   {plik_wy<< "<"<<etykieta<<">";}

   void Zachowaj_nazwe(ofstream& plik_wy, char* nazwa)
   {plik_wy<< nazwa<<endl;}

   void Zachowaj_naglowek(ofstream& plik_wy,char* etykieta,char* nazwa)
   { Zachowaj_etykiete(plik_wy,etykieta);
     Zachowaj_nazwe(plik_wy,nazwa);}

   void Zachowaj_ID(ofstream& plik_wy, int obiekt_ID)
    { char pom[80];
      itoa(obiekt_ID,pom,10);
      Zachowaj_naglowek(plik_wy,"id", pom);}

   int Odtworz_etykiete(ifstream& plik_we, char* etykieta)
   { char znak,znaki[80];
     long pozycja= plik_we.tellg();
      plik_we.get(znak); //'<'
      plik_we.get(znaki,80,'>');
      if (strcmp(etykieta,znaki)==0)
       {plik_we.get(znak); //'>'
	return 1;}
      else
      { plik_we.seekg(pozycja);
	return 0;}}

  char* Odtworz_nazwe(ifstream& plik_we)
   { char znak,*znaki=new char[80];
     plik_we.get(znaki,80,'<');
     int rozmiar = strlen(znaki);
     if (znaki[rozmiar-1]=='\n')
       znaki[rozmiar-1]='\0';
     return znaki;}

  char* Odtworz_naglowek(ifstream& plik_we,char* etykieta)
   { Odtworz_etykiete(plik_we,etykieta);
     return Odtworz_nazwe(plik_we);}

  int Odtworz_ID(ifstream& plik_we)
   { if (!(Odtworz_etykiete(plik_we,"id")))
      return -1;
     char* ID=Odtworz_nazwe(plik_we);
     int obiekt_ID=atoi(ID);
     delete ID;
     return obiekt_ID;}
   friend ostream& operator<<(ostream& a, const Format_obiektow& b)
    {return a;}
};
#endif