#ifndef FORM_PDC
#define FORM_PDC
#include <string.h>
#include <stdlib.h>
#include "Form_OB.h"

template <class PDC_Typ>
class Format_PDC_obiektow:public Format_obiektow
{ protected:
  PDC_Typ* pdc_obiekt;
  public:
  Format_PDC_obiektow () {}
  ~Format_PDC_obiektow() {}

  virtual void Zachowaj(ofstream& plik_wy)
   { Zachowaj_poczatek_def(plik_wy);
     Zachowaj_nazwe_klasy(plik_wy);
     Zachowaj_obiekt_ID(plik_wy);
     Zachowaj_atrybuty(plik_wy);
     Zachowaj_powiazania(plik_wy);
     Zachowaj_koniec_def(plik_wy);
   }

  virtual void Odtworz(ifstream& plik_we,Tablica_obiektow* tablica_obiektow)
   {
     Odtworz_poczatek_def(plik_we);
     Odtworz_nazwe_klasy(plik_we);
     Odtworz_obiekt_ID(plik_we);
     Odtworz_atrybuty(plik_we);
     Odtworz_powiazania(plik_we,tablica_obiektow);
     Odtworz_koniec_def(plik_we);
     }

  virtual void Nadaj_obiekt(void* _obiekt)
   {pdc_obiekt= (PDC_Typ*)_obiekt; }

  void Nadaj_pdc_obiekt(PDC_Typ& _obiekt)
   {pdc_obiekt= &_obiekt; }

  PDC_Typ& Podaj_pdc_obiekt()
   {return *pdc_obiekt; }

   void Zachowaj_obiekt_ID(ofstream& plik_wy)
    { int obiekt_ID=pdc_obiekt->Podaj_obiekt_ID();
      Zachowaj_etykiete(plik_wy,"Obiekt_ID");
      Zachowaj_ID(plik_wy,obiekt_ID);}

  void Odtworz_obiekt_ID(ifstream& plik_we)
   { if (!(Odtworz_etykiete(plik_we,"Obiekt_ID")))
      return;
     int obiekt_ID=Odtworz_ID(plik_we);
     pdc_obiekt->Nadaj_obiekt_ID(obiekt_ID);}
};
#endif