#include "Form_ob.h"
#include "Form_PDC.h"
#include "PDC_Ob.h"
#include "M_bibl1.h"

#include "TTytul4.h"
#include "TPoz3.h"
#include "kol2_2.h"
#include "TKlient5.h"
#include "TWyp1.h"
#include "TRez1.h"

void Wstaw_tytul(char*, char*, char*);
void Zwieksz_zasob(char*,int);
void Zmniejsz_zasob(char*,int);
void Szukaj_wyswietl_zasob(char*);

void Wypozycz_zasob(int,char*);
void Zwroc_zasob(int,int);
void Wypozycz_zasob_lub_zarezerwuj(int,char*);
void Wypozycz_zarezerwowany_zasob(int,char* );

void Wstaw_klienta(char*, char*, char*, char*,int);
void Szukaj_wyswietl(char*);
void Szukaj_wyswietl(int);

TKol3<TDane_klienta> Klienci;
TKol3<TTytul> Zasoby;
TKol3<TPozycja> Pozycje;
TKol3<TWypozyczenie> Wypozyczenia;
TKol3<TRezerwacja> Rezerwacje;

void main()
{
  clrscr();
//Odczyt obiektow
   Tablica_obiektow tablica_obiektow;
   Mapa_bibl* mapa_bibl= new Mapa_bibl;
   tablica_obiektow.Nadaj_mape_klas(mapa_bibl);
   tablica_obiektow.Odczytaj("prob1.txt");
   tablica_obiektow.Zapisz("prob2.txt");
   cout<<"\nZasoby\n"<<Zasoby<<endl;
   cout<<"\nPozycje\n"<<Pozycje<<endl;
   cout<<"\nKlienci\n"<<Klienci<<endl;
   cout<<"\nWypozyczenia\n"<<Wypozyczenia<<endl;
   cout<<"\nRezerwacje\n"<<Rezerwacje<<endl;

   Rezerwacje.Usun_kolekcje();
   Wypozyczenia.Usun_kolekcje();
   Pozycje.Usun_kolekcje();
   Klienci.Usun_kolekcje();
   Zasoby.Usun_kolekcje();
   getch();
}

void Wstaw_tytul(char*a, char*b, char*c)
{int indeks;
//wyszukiwanie sekwencyjne z kolekcji TKol1
 if (Zasoby.TKol1<TTytul>::Szukaj(Szukaj_wg_Tytulu,indeks,a)
	 ==NULL)
	{TTytul* Tytul= new TTytul(a,b,c,&Pozycje,&Rezerwacje);
	 if(Tytul)
	if (Zasoby.Zmien(1))
		 Zasoby.Wstaw(Tytul,0);
	else delete Tytul;}
}

void Szukaj_wyswietl_zasob(char*b)
{TTytul*Tytul; int indeks;
 //wyszukiwanie binarne bez powtorzen z kolekcji TKol3
 Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,indeks,b);
 if(Tytul)
 cout<<"\nZnaleziono ksiazke: \n"<<*Tytul<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono ksiazki o tytule "<<b<<endl;
}

void Zwieksz_zasob(char*ctytul,int numer)
{ TTytul* Tytul;
  int ktory;
  if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
    Tytul->Wstaw_pozycje(NULL,numer);
  else cout<<"\nNie znaleziono ksiazki o tytule "<<ctytul<<endl;
}

void Zmniejsz_zasob(char* ctytul, int numer)
{ TTytul* Tytul;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
    Tytul->Usun_pozycje(numer);
  else cout<<"\nNie znaleziono ksiazki o tytule "<<ctytul<<endl;
}


void Wypozycz_zasob(int nnumer,char*ctytul)
{TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
 if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
  if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&nnumer))!=NULL)
    Klient->Dodaj_wypozyczenie(Pozycja);
}

 void Zwroc_zasob(int nnumer, int numer)
 {TDane_klienta* Klient;
  int ktory;
  if((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&nnumer))!=NULL)
    Klient->Usun_wypozyczenie(numer);
 }

void Wstaw_klienta(char*a, char*b, char*c, char*d,int _numer)
{int indeks;
//wyszukiwanie sekwencyjne z kolekcji TKol1
 if (Klienci.TKol1<TDane_klienta>::Szukaj(Szukaj_wg_Numeru,indeks,&_numer)
     ==NULL)
   {TDane_klienta* Klient= new TDane_klienta(_numer,a,b,c,d,
			 &Wypozyczenia,&Rezerwacje);
    if(Klient)
      if (Klienci.Zmien(1))
	 Klienci.Wstaw(Klient,0);
    else delete Klient;}
}

void Szukaj_wyswietl(int b)
{TDane_klienta*Klient; int indeks;
 //wyszukiwanie binarne bez powtorzen z kolekcji TKol3
 Klient=Klienci.Szukaj(Szukaj_wg_Numeru,indeks,&b);
 if(Klient)
  cout<<"\nZnaleziono klienta: \n"<<*Klient<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono klienta o numerze "<<b<<endl;
}

void Szukaj_wyswietl(char*b)
{ TDane_klienta*Klient; int indeks;
 //wyszukiwanie binarne z powtorzeniemi z kolekcji TKol2
 Klient=Klienci.TKol2<TDane_klienta>::Szukaj(Szukaj_wg_Nazwiska,indeks,b);
 if(Klient)
  cout<<"\nZnaleziono klienta: \n"<<*Klient<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono klienta o nazwisku "<<b<<endl;
}

void Wypozycz_zasob_lub_zarezerwuj(int numer,char*ctytul)
{TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
  if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
   {if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
     Klient->Dodaj_wypozyczenie(Pozycja);}
     else
      if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
	Klient->Dodaj_rezerwacje(Tytul);
}

 void Wypozycz_zarezerwowany_zasob(int numer,char* ctytul)
 {
 TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
  if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
   if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
    {
     Klient->Dodaj_wypozyczenie(Pozycja);
     Klient->Usun_rezerwacje(Tytul);
    }
 }