#include "M_bibl1.h"
#include "TTytul4.h"
#include "TPoz3.h"
#include "kol2_2.h"
#include "TKlient5.h"
#include "TWyp1.h"
#include "TRez1.h"

void Wstaw_tytul(char*, char*, char*);
void Zwieksz_zasob(char*,int);
void Zmniejsz_zasob(char*,int);
void Szukaj_wyswietl_zasob(char*);

void Wypozycz_zasob(int,char*);
void Zwroc_zasob(int,int);
void Wypozycz_zasob_lub_zarezerwuj(int,char*);
void Wypozycz_zarezerwowany_zasob(int,char* );

void Wstaw_klienta(char*, char*, char*, char*,int);
void Szukaj_wyswietl(char*);
void Szukaj_wyswietl(int);

TKol3<TDane_klienta> Klienci;
TKol3<TTytul> Zasoby;
TKol3<TPozycja> Pozycje;
TKol3<TWypozyczenie> Wypozyczenia;
TKol3<TRezerwacja> Rezerwacje;

void main()
{
	clrscr();
//wstaw kilka ksiazek o niepowtarzalnym tytule
	Wstaw_tytul("Tytul4","4","4");
	Wstaw_tytul("Tytul1","1","1");
	Wstaw_tytul("Tytul3","3","3");
	Wstaw_tytul("Tytul2","2","2");
	cout<<Zasoby<<endl;
//sortowanie wg tytulu -
	Zasoby.Sortuj(Porownaj_wg_Tytulu);
	cout<<Zasoby<<endl;
//szukanie binarne bez powtorzen wg tytulu
	Szukaj_wyswietl_zasob("Tytul1");
	Szukaj_wyswietl_zasob("Tytul2");
	Szukaj_wyswietl_zasob("Tytul5");

	Zwieksz_zasob("Tytul1",1);
	Zwieksz_zasob("Tytul2",1);
	Zwieksz_zasob("Tytul8",2);
	Zwieksz_zasob("Tytul2",2);
	Zwieksz_zasob("Tytul3",3);
	Zwieksz_zasob("Tytul4",4);
	Zwieksz_zasob("Tytul1",5);
	cout<<Pozycje<<endl;

	Zmniejsz_zasob("Tytul1",1);
	cout<<Pozycje<<endl;

//sortowanie wg numeru - kazda pozycja ma inny numer
	Pozycje.Sortuj(Porownaj_wg_Numeru);
	cout<<Pozycje<<endl;

//wstaw kilku klientow o niepowtarzalnym numerze
	Wstaw_klienta("Kowalski","1","1","1",2);
	Wstaw_klienta("Nowak","2","2","2",2);
	Wstaw_klienta("Adamiak","3","3","3",1);
	Wstaw_klienta("Walczak","4","4","4",3);
	cout<<Klienci<<endl;
//sortowanie wg nazwiska - moze byc wiele osob o tym samym nazwisku
	Klienci.Sortuj(Porownaj_wg_Nazwiska);
	cout<<Klienci<<endl;
//szukanie binarne z powtorzeniami wg nazwiska
	Szukaj_wyswietl("Kowalski");
	Szukaj_wyswietl("Walczak");
	Szukaj_wyswietl("Kowal");
//sortowanie wg numeru - kazda osoba ma inny numer
	Klienci.Sortuj(Porownaj_wg_Numeru);
	cout<<Klienci<<endl;
//szukanie binarne bez powtorzen wg numeru
	Szukaj_wyswietl(1);
	Szukaj_wyswietl(3);
	Szukaj_wyswietl(4);
	Wypozycz_zasob(2,"Tytul1"); //numer 5
	Wypozycz_zasob(2,"Tytul2"); //numer2
	cout<<"\nWypozyczenia"<<endl<<Wypozyczenia<<endl;
	cout<<"\nPozycje"<<endl<<Pozycje<<endl;
	Zwroc_zasob(2,5);
	cout<<"\nWypozyczenia po zwrocie"<<endl<<Wypozyczenia<<endl;
	cout<<"\nPozycje po zwrocie"<<endl<<Pozycje<<endl;

//rezerwacja: we: nazwisko klienta oraz tytul
//wy: wypozyczenie albo rezerwacja
	Wypozycz_zasob_lub_zarezerwuj(4,"Tytul2");
	Wypozycz_zasob_lub_zarezerwuj(3,"Tytul2");
	cout<<"\nWypozyczenia\n"<<Wypozyczenia<<endl;
	cout<<"\nRezerwacje\n"<<Rezerwacje<<endl;

//Zapis obiektow
   Tablica_obiektow tablica_obiektow;
   Mapa_bibl* mapa_bibl= new Mapa_bibl;
   tablica_obiektow.Nadaj_mape_klas(mapa_bibl);

   Zasoby.Zarejestruj_w_tablicy(&tablica_obiektow);
   Pozycje.Zarejestruj_w_tablicy(&tablica_obiektow);
   Klienci.Zarejestruj_w_tablicy(&tablica_obiektow);
   Wypozyczenia.Zarejestruj_w_tablicy(&tablica_obiektow);
   Rezerwacje.Zarejestruj_w_tablicy(&tablica_obiektow);

   tablica_obiektow.Zapisz("prob1.txt");


	Rezerwacje.Usun_kolekcje();
	Wypozyczenia.Usun_kolekcje();
	Pozycje.Usun_kolekcje();
	Klienci.Usun_kolekcje();
	Zasoby.Usun_kolekcje();
	getch();

}

void Wstaw_tytul(char*a, char*b, char*c)
{int indeks;
//wyszukiwanie sekwencyjne z kolekcji TKol1
 if (Zasoby.TKol1<TTytul>::Szukaj(Szukaj_wg_Tytulu,indeks,a)
	 ==NULL)
	{TTytul* Tytul= new TTytul(a,b,c,&Pozycje,&Rezerwacje);
	 if(Tytul)
	if (Zasoby.Zmien(1))
		 Zasoby.Wstaw(Tytul,0);
	else delete Tytul;}
}

void Szukaj_wyswietl_zasob(char*b)
{TTytul*Tytul; int indeks;
 //wyszukiwanie binarne bez powtorzen z kolekcji TKol3
 Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,indeks,b);
 if(Tytul)
 cout<<"\nZnaleziono ksiazke: \n"<<*Tytul<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono ksiazki o tytule "<<b<<endl;
}

void Zwieksz_zasob(char*ctytul,int numer)
{ TTytul* Tytul;
  int ktory;
  if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
    Tytul->Wstaw_pozycje(NULL,numer);
  else cout<<"\nNie znaleziono ksiazki o tytule "<<ctytul<<endl;
}

void Zmniejsz_zasob(char* ctytul, int numer)
{ TTytul* Tytul;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
    Tytul->Usun_pozycje(numer);
  else cout<<"\nNie znaleziono ksiazki o tytule "<<ctytul<<endl;
}


void Wypozycz_zasob(int nnumer,char*ctytul)
{TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
 if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
  if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&nnumer))!=NULL)
    Klient->Dodaj_wypozyczenie(Pozycja);
}

 void Zwroc_zasob(int nnumer, int numer)
 {TDane_klienta* Klient;
  int ktory;
  if((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&nnumer))!=NULL)
    Klient->Usun_wypozyczenie(numer);
 }

void Wstaw_klienta(char*a, char*b, char*c, char*d,int _numer)
{int indeks;
//wyszukiwanie sekwencyjne z kolekcji TKol1
 if (Klienci.TKol1<TDane_klienta>::Szukaj(Szukaj_wg_Numeru,indeks,&_numer)
     ==NULL)
   {TDane_klienta* Klient= new TDane_klienta(_numer,a,b,c,d,
			 &Wypozyczenia,&Rezerwacje);
    if(Klient)
      if (Klienci.Zmien(1))
	 Klienci.Wstaw(Klient,0);
    else delete Klient;}
}

void Szukaj_wyswietl(int b)
{TDane_klienta*Klient; int indeks;
 //wyszukiwanie binarne bez powtorzen z kolekcji TKol3
 Klient=Klienci.Szukaj(Szukaj_wg_Numeru,indeks,&b);
 if(Klient)
  cout<<"\nZnaleziono klienta: \n"<<*Klient<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono klienta o numerze "<<b<<endl;
}

void Szukaj_wyswietl(char*b)
{ TDane_klienta*Klient; int indeks;
 //wyszukiwanie binarne z powtorzeniemi z kolekcji TKol2
 Klient=Klienci.TKol2<TDane_klienta>::Szukaj(Szukaj_wg_Nazwiska,indeks,b);
 if(Klient)
  cout<<"\nZnaleziono klienta: \n"<<*Klient<<"o indeksie: "<<indeks<<endl;
 else cout<<"\nNie znaleziono klienta o nazwisku "<<b<<endl;
}

void Wypozycz_zasob_lub_zarezerwuj(int numer,char*ctytul)
{TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
  if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
   {if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
     Klient->Dodaj_wypozyczenie(Pozycja);}
     else
      if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
	Klient->Dodaj_rezerwacje(Tytul);
}

 void Wypozycz_zarezerwowany_zasob(int numer,char* ctytul)
 {
 TDane_klienta* Klient;
 TTytul* Tytul;
 TPozycja *Pozycja;
 int ktory;
 if ((Klient=Klienci.Szukaj(Szukaj_wg_Numeru,ktory,&numer))!=NULL)
  if ((Tytul=Zasoby.Szukaj(Szukaj_wg_Tytulu,ktory,ctytul))!=NULL)
   if ((Pozycja=Tytul->Szukaj_pozycje())!=NULL)
    {
     Klient->Dodaj_wypozyczenie(Pozycja);
     Klient->Usun_rezerwacje(Tytul);
    }
 }