#include "Tab_ob.h"
#include "PDC_ob.h"
#include "Mapa_kl.h"
#include "Form_Ob.h"

   void* Tablica_obiektow::Obiekt_ID(int obiekt_ID)
     { int i=0;
       while (i<ile)
 	if(id_obiektow[i]==obiekt_ID) return obiekty[i];
	else i++;
       return NULL;}

   int Tablica_obiektow::Szukaj_ID(int obiekt_ID)
     { int Jest=0;
       for (int i=0;i<ile;i++)
	if ((Jest=(id_obiektow[i]==obiekt_ID))==1) break;
       return Jest;}

 void Tablica_obiektow::Zarejestruj_obiekt(int obiekt_ID,
 PDC_Obiekt* pdc_obiekt)
    { if (!(Szukaj_ID(obiekt_ID))&& ile<MAX_OB)
      {id_obiektow[ile]=obiekt_ID;
       obiekty[ile++]=pdc_obiekt;
      }
    }

 int Tablica_obiektow::Zapisz(char* nazwa)
    { ofstream plik_wy(nazwa,ios::out);
      if (!plik_wy) return 0;
      Zachowaj(plik_wy);
      Zachowaj_obiekty(plik_wy);
      plik_wy.close();
      return 1;
    }

   void Tablica_obiektow::Zachowaj(ofstream& plik_wy)
    { Format_obiektow* format= mapa_klas->Podaj_format_tablicy();
      format->Nadaj_obiekt(this);
      format->Zachowaj(plik_wy);
    }

   void Tablica_obiektow::Zachowaj_obiekty(ofstream& plik_wy)
    { for (int i=0;i<ile;i++)
       obiekty[i]->Zachowaj_wg_tablicy(plik_wy,this);
    }

   int Tablica_obiektow::Odczytaj(char* nazwa)
   { ifstream plik_we(nazwa,ios::in);
      if (!plik_we) return 0;
      Odtworz(plik_we);
      Odtworz_obiekty(plik_we);
     plik_we.close();
      return 1;
    }

   void Tablica_obiektow::Odtworz(ifstream& plik_we)
    { Format_obiektow* format=mapa_klas->Podaj_format_tablicy();
      format->Nadaj_obiekt(this);
      format->Odtworz(plik_we,this);
    }

   void Tablica_obiektow::Odtworz_obiekty(ifstream& plik_we)
    { for (int i=0;i<ile;i++)
       obiekty[i]->Odtworz_wg_tablicy(plik_we,this);
    }

